/* VMSstdio - VMS extensions to stdio routines 
 *
 * Version:  1.0
 * Author:   Charles Bailey  bailey@genetics.upenn.edu
 * Revised:  23-Nov-1994
 *
 *
 * Revision History:
 * 
 * 1.0  29-Nov-1994  Charles Bailey  bailey@genetics.upenn.edu
 *      original version - vmsfopen
 */

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

/* Use type for FILE * from Perl's XSUB typemap.  This is a bit
 * of a hack, since all Perl filehandles using this type will permit
 * both read & write operations, but it saves to write the PPCODE
 * directly for updating the Perl filehandles.
 */
typedef FILE * InOutStream;

MODULE = File::VMSstdio  PACKAGE = File::VMSstdio

int
vmsfopen(fp,name,...)
	InOutStream	fp = NO_INIT
	char *	name
	CODE:
	    char *args[8],mode[3] = {'r','\0','\0'}, *cp;
	    register int i, myargc;
	    if (items > 10) {
	      croak("File::VMSfopen::vmsfopen - too many args");
	    }
	    /* First, set up name and mode args from perl's string */
	    if (*name == '+') {
	      mode[1] = '+';
	      name++;
	    }
	    if (*name == '>') {
	      if (*(name+1) == '>') *mode = 'a', name += 2;
	      else *mode = 'w',  name++;
	    }
	    myargc = items - 2;
	    for (i = 0; i < myargc; i++) args[i] = SvPV(ST(i+2),na);
	    /* This hack brought to you by C's opaque arglist management */
	    switch (myargc) {
	      case 0:
	        fp = fopen(name,mode);
	        break;
	      case 1:
	        fp = fopen(name,mode,args[0]);
	        break;
	      case 2:
	        fp = fopen(name,mode,args[0],args[1]);
	        break;
	      case 3:
	        fp = fopen(name,mode,args[0],args[1],args[2]);
	        break;
	      case 4:
	        fp = fopen(name,mode,args[0],args[1],args[2],args[3]);
	        break;
	      case 5:
	        fp = fopen(name,mode,args[0],args[1],args[2],args[3],args[4]);
	        break;
	      case 6:
	        fp = fopen(name,mode,args[0],args[1],args[2],args[3],args[4],args[5]);
	        break;
	      case 7:
	        fp = fopen(name,mode,args[0],args[1],args[2],args[3],args[4],args[5],args[6]);
	        break;
	      case 8:
	        fp = fopen(name,mode,args[0],args[1],args[2],args[3],args[4],args[5],args[6],args[7]);
	        break;
	    }
	    if (fp == NULL) RETVAL = FALSE;
	    else RETVAL = TRUE;
	OUTPUT:
	fp
	RETVAL
